<? require(dirname(__FILE__) . "/" . "netpbm.config.php"); ?>
<?
	function netpbm__scale($str_filename_original,$str_filename_target,$flo_scale_factor) {
		global $_ERRORS;
		global $arr_config_executables;
		
		$bol_output = FALSE;
		if(file_exists($arr_config_executables["scale"])) {
			$str_shell_cmd = $arr_config_executables["scale"] . " " . $flo_scale_factor . " \"" . "[tmp_file_01]" . "\" > \"" . "[tmp_file_02]" . "\"";
			//print($str_shell_cmd . "<br>");
			
			$bol_output	= netpbm__action($str_filename_original,$str_filename_target,$str_shell_cmd);
		}
		else
			$_ERRORS["netpbm__scale"][] = "Scale executable '" . $arr_config_executables["scale"] . "' doesn't exist.";
		
		return $bol_output;
	}
	
	function netpbm__flip($str_filename_original,$str_filename_target,$int_deg) {
		global $_ERRORS;
		global $arr_config_executables;
		
		$bol_output = FALSE;
		
		if(file_exists($arr_config_executables["flip"])) {
			$str_shell_cmd = $arr_config_executables["flip"] . " " . "-r" . $int_deg . " " . "\"" . "[tmp_file_01]" . "\" > \"" . "[tmp_file_02]" . "\"";
			//print($str_shell_cmd . "<br>");
		
			$bol_output	= netpbm__action($str_filename_original,$str_filename_target,$str_shell_cmd);
		}
		else
			$_ERRORS["netpbm__flip"][] = "Flip executable '" . $arr_config_executables["flip"] . "' doesn't exist.";
		
		return $bol_output;
	}
	
	function netpbm__action($str_filename_original,$str_filename_target,$str_shell_cmd) {
		global $_ERRORS;
		global $str_config_tmp_folder;
		
		$bol_output = FALSE;
		
		$str_filename_ppm = netpbm__create_ppm($str_filename_original);
		
		if(file_exists($str_filename_ppm) && filesize($str_filename_ppm) > 0 && is_dir(dirname($str_filename_target))) {
			$str_filename_ppm_actioned = $str_config_tmp_folder . md5($str_filename_target) . ".ppm";
			
			$arr_filename_replacements = Array();
			$arr_filename_replacements[] = Array("[tmp_file_01]",$str_filename_ppm);
			$arr_filename_replacements[] = Array("[tmp_file_02]",$str_filename_ppm_actioned);
			
			foreach($arr_filename_replacements as $arr_filename_replacement)
				$str_shell_cmd = str_replace($arr_filename_replacement[0],$arr_filename_replacement[1],$str_shell_cmd);
			
			$str_shell_response = shell_exec($str_shell_cmd);
			//print($str_shell_cmd . "<br>" . $str_shell_response . "<br><br>");
			
			if(file_exists($str_filename_ppm_actioned) && filesize($str_filename_ppm_actioned) > 0) {
				$bol_output = netpbm__recreate_image($str_filename_ppm_actioned,$str_filename_target);
				
				//if(!unlink($str_filename_ppm))
					//$_ERRORS["netpbm__action"][] = "Temporary file '" . $str_filename_ppm . "' (original ppm) couldn't have been deleted.";
				
				if(file_exists($str_filename_ppm_actioned) && !unlink($str_filename_ppm_actioned))
					$_ERRORS["netpbm__action"][] = "Temporary file '" . $str_filename_ppm_actioned . "' (actioned ppm) couldn't have been deleted.";
			}
			else
				$_ERRORS["netpbm__action"][] = "Actioned file '" . $str_filename_ppm_actioned . "' hasn't been created. Executable reported '" . $str_shell_response . "'.";
		}
		else
			$_ERRORS["netpbm__action"][] = "Some of the following files couldn't have been found: '" . $str_filename_ppm . "','" . dirname($str_filename_target) . "'.";
		
		return $bol_output;
	}
	
	function netpbm__create_ppm($str_filename_original) {
		global $_ERRORS;
		global $str_config_tmp_folder;
		global $arr_config_valid_image_types;
		
		$str_filename_ppm = NULL;
		
		if(file_exists($str_filename_original) && filesize($str_filename_original) > 0) {
			$str_filename_ppm_tmp = $str_config_tmp_folder . md5($str_filename_original) . ".ppm";
			
			if(file_exists($str_filename_ppm_tmp) && filesize($str_filename_ppm_tmp) > 0) {
				$str_filename_ppm = $str_filename_ppm_tmp;
			}
			else {
				$arr_file_info	= pathinfo($str_filename_original);
				$str_file_ext	= strtolower($arr_file_info["extension"]);
				
				$GLOBALS["file_ext"] = $str_file_ext;
				
				if(in_array($str_file_ext,$arr_config_valid_image_types)) {
					$str_converter_filename = netpbm__get_converter_filename($str_file_ext,FALSE);
					
					if(file_exists($str_converter_filename) && filesize($str_converter_filename) > 0) {
						$str_filename_ppm = $str_filename_ppm_tmp;
						$str_shell_cmd = $str_converter_filename . " \"" . $str_filename_original . "\" > \"" . $str_filename_ppm . "\"";
						
						$str_shell_response = shell_exec($str_shell_cmd);
						//print($str_shell_cmd . "<br>" . $str_shell_response . "<br><br>");
						
						if(file_exists($str_filename_ppm) && filesize($str_filename_ppm) > 0) {
						}
						else {
							$_ERRORS["netpbm__create_ppm"][] = "File '" . $str_filename_ppm . "' hasn't been created. Executable reported '" . $str_shell_response . "'.";
							
							$str_filename_ppm = NULL;
						}
					}
					else
						$_ERRORS["netpbm__create_ppm"][] = "Converter executable '" . $str_converter_filename . "' doesn't exist.";
				}
				else
					$_ERRORS["netpbm__create_ppm"][] = "Image-Type '" . $str_file_ext . "' isn't supported.";
			}
		}
		else
			$_ERRORS["netpbm__create_ppm"][] = "File '" . $str_filename_original . "' doesn't exist.";
		
		return $str_filename_ppm;
	}
	
	function netpbm__recreate_image($str_filename_ppm,$str_filename_target) {
		global $_ERRORS;
		global $str_config_tmp_folder;
		global $arr_config_needs_quantization;
		global $arr_config_executables;
		global $int_config_jpeg_quality;
		
		$bol_output = FALSE;
		
		if(file_exists($str_filename_ppm) && filesize($str_filename_ppm)) {
			$str_target_file_ext = NULL;
			
			$arr_pathinfo = pathinfo($str_filename_target);
			if(isset($arr_pathinfo["extension"]))
				$str_target_file_ext = strtolower($arr_pathinfo["extension"]);
			
			if(netpbm__is_valid_image_type($str_target_file_ext)) {
				if(isset($arr_config_needs_quantization[$str_target_file_ext]))
					$str_filename_ppm = netpbm__quantize($str_filename_ppm,$arr_config_needs_quantization[$str_target_file_ext]);
				else
					$_ERRORS["netpbm__recreate_image"][] = "Notice: Image type doesn't need quantization.";
				
				if(file_exists($str_filename_ppm)) {
					$str_converter_filename = netpbm__get_converter_filename($str_target_file_ext,TRUE);
					
					if(file_exists($str_converter_filename)) {
						$str_shell_cmd_quality = NULL;
						if($str_target_file_ext == "jpeg" || $str_target_file_ext == "jpg")
							$str_shell_cmd_quality = " -quality=" . $int_config_jpeg_quality;
						
						$str_shell_cmd = $str_converter_filename . " " . "\"" . $str_filename_ppm . "\" > \"" . $str_filename_target . "\"" . $str_shell_cmd_quality;
						
						$str_shell_response = shell_exec($str_shell_cmd);
						//print($str_shell_cmd . "<br>" . $str_shell_response . "<br><br>");
						
						if(file_exists($str_filename_target) && filesize($str_filename_target) > 0)
							$bol_output = TRUE;
						else
							$_ERRORS["netpbm__recreate_image"][] = "Final file '" . $str_filename_target . "' hasn't been created. Executable reported '" . $str_shell_response . "'.";
					}
					else
						$_ERRORS["netpbm__recreate_image"][] = "Scale executable '" . $str_converter_filename . "' doesn't exist.";
				}
				else
					$_ERRORS["netpbm__recreate_image"][] = "File '" . $str_filename_ppm . "' doesn't exist.";
			}
			else
				$_ERRORS["netpbm__recreate_image"][] = "Output image type (guessed upon extension) of '" . $str_filename_target . "' not supported.";
		}
		else
			$_ERRORS["netpbm__recreate_image"][] = "File '" . $str_filename_ppm . "' doesn't exist.";
			
		return $bol_output;
	}
	
	function netpbm__quantize($str_filename_ppm,$int_num_colors) {
		global $_ERRORS;
		global $str_config_tmp_folder;
		global $arr_config_executables;
		
		$str_output = NULL;
		
		$str_quant_filename = $arr_config_executables["quant"];
		
		if(file_exists($str_quant_filename)) {
			$str_filename_ppm_quant = $str_config_tmp_folder . md5($str_filename_ppm) . ".ppm";
			$str_shell_cmd = $str_quant_filename . " " . $int_num_colors . " \"" . $str_filename_ppm . "\" > \"" . $str_filename_ppm_quant . "\"";
			
			$str_shell_response = shell_exec($str_shell_cmd);
			//print($str_shell_cmd . "<br>" . $str_shell_response . "<br><br>");
			
			if(file_exists($str_filename_ppm_quant) && filesize($str_filename_ppm_quant)) {
				$str_output = $str_filename_ppm_quant;
				
				if(file_exists($str_filename_ppm) && !unlink($str_filename_ppm))
					$_ERRORS["netpbm__quantize"][] = "Temporary file '" . $str_filename_ppm . "' [actioned_ppm_before_quant] couldn't have been deleted.";
			}
			else
				$_ERRORS["netpbm__quantize"][] = "Quantized file '" . $str_filename_ppm_actioned . "' hasn't been created. Quantizer reported '" . $str_shell_response . "'.";
		}
		else
			$_ERRORS["netpbm__quantize"][] = "Quant executable '" . $str_quant_filename . "' not found.";
		
		return $str_output;
	}
	
	function netpbm__get_converter_filename($str_file_ext,$bol_reverse) {
		global $arr_config_converters;
		global $arr_config_converters_reverse;
		
		$str_output = NULL;
		
		if($bol_reverse)
			$arr_filenames = $arr_config_converters_reverse;
		else
			$arr_filenames = $arr_config_converters;
		
		if(isset($arr_filenames[$str_file_ext]))
			$str_output = $arr_filenames[$str_file_ext];
		
		return $str_output;
	}
	
	function netpbm__is_valid_image_type($str_file_ext) {
		global $arr_config_valid_image_types;
		
		$bol_output = FALSE;
		
		if(in_array($str_file_ext,$arr_config_valid_image_types))
			$bol_output = TRUE;
		
		return $bol_output;
	}
	
	function netpbm__cleanup() {
		global $str_config_tmp_folder;
		
		$bol_output = FALSE;
		
		$ptr_tmp_folder = opendir($str_config_tmp_folder);
		
		while(FALSE !== ($str_filename = readdir($ptr_tmp_folder))) {
			if($str_filename != "." && $str_filename != "..") {
				$str_file_path = $str_config_tmp_folder . $str_filename;
				
				$arr_pathinfo = pathinfo($str_file_path);
				
				if(strtolower($arr_pathinfo["extension"]) == "ppm" && file_exists($str_file_path)) {
					//print($str_file_path . "<br>");
					unlink($str_file_path);
				}
			}
		}
		
		return $bol_output;
	}
?>